(
	global VDMTT_Rollout
	try (destroydialog VDMTT_Rollout)catch()
	
	local textoBake = undefined
	local numViews  = undefined
	local viewName  = undefined
	local lastView = undefined
	local newNode = undefined
	local newSHader = undefined
	local getCompatibleMaps = undefined
	local getCompatibleMapsNames = undefined
	local index = undefined
	local dir = undefined
	
	rollout VDMTT_Rollout "VRayDisplacementMod tex to BTT"
(
	button 'btn1' "Bake" pos:[10,10] width: 240 height: 40 align:#center tooltip: "This script will take the textures plugged in the selected objects' VRayDisplacementMod, create a new VRayMtl, plug the taken texture to its diffuse slot, apply the shader and create a VRayDiffuseFilterMap for baking."
	
	fn isVRayCurrent = matchPattern (renderers.current as string) pattern:"*V_RAY*"
	fn getObjsUsingMod objs mod = (for o in objs where ((findItem (for m in o.modifiers collect classOf m) mod) > 0) collect o)
	fn isDispModThere = (getObjsUsingMod selection VRayDisplacementMod)
	fn openSME = (
	if sme.isopen() == false do 
		(
			sme.open()
			sme.close()
		)
	)
	
	fn BakeHeightMap = (
		for each in selection do (
			textoBake = each.VRayDisplacementMod.texmap
			numViews = SME.GetNumViews()
			viewName = each.name
			SME.CreateView viewName
			numViews = SME.GetNumViews()
			lastView= SME.getView numViews
			LastView.createNode (VRayMtl()) [0,0]
			newNode = LastView.getNode 1
			newShader = newNode.reference
			newShader.texmap_diffuse = textoBake
			each.material = newShader
			index = sme.getviewindex lastView
			sme.deleteview index false
			
			BakeToTexture.showDialog()
			diffMap = BakeToTexture.addMapByClassID each #(1239043254, 1808104227)
			diffMap.filename = each.name + "_VRayHeightMap"
			)
		)
		
	on btn1 pressed do 
	(
		if isVRayCurrent() == true then print "Okay." else return messageBox "V-Ray is not set to current renderer!" title: "Error!"
		if $ != undefined then print "Okay." else return messageBox "No objects selected." title: "Error!"
		if (isDispModThere()).count == selection.count then print "Okay." else return messageBox "One or more objects do not have a VRayDisplacementMod applied." title: "Error!"
		openSME()
		BakeHeightMap()
	)
)
	createDialog VDMTT_Rollout 260 60
)